//+------------------------------------------------------------------+
//|                                                  EntropyMath.mq4 |
//|                                         Aleksandr Pak            |
//+------------------------------------------------------------------+

#property  copyright "Copyright  2008, MetaQuotes Software Corp."
#property  link      "http://forum.mql4.com/ru/13708"
#property indicator_separate_window

#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

#property indicator_level1 0.0001
#property indicator_level2 -0.0001

double entropy[],SignalBuffer[];

extern int numbars=14;
extern int SignalSMA=5;
	
	
//+------------------------------------------------------------------+
int init()
{
	SetIndexBuffer(0,entropy);  SetIndexStyle(0,DRAW_HISTOGRAM); 
	SetIndexBuffer(1,SignalBuffer); 
	IndicatorDigits(Digits+2);
	IndicatorShortName("Entropy("+numbars+")");
	return(0);
}
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+
int start ()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--) 
	{
      	double sumx  = 0.0;
	      double sumx2 = 0.0;
	      double avgx  = 0.0;
	      double rmsx  = 1.0;
			for (int j=0;j<numbars+1 && (i+j+1)<Bars; j++)
			{
				double r=MathLog(Close[i+j] / Close[i+j+1]) ;
				sumx += r;
				sumx2 += r * r;
			}
		   if (numbars==0)  
		         { avgx = Close[i];       rmsx = 0.0;                     }
		   else  { avgx = sumx / numbars; rmsx = MathSqrt(sumx2/numbars); }
		   if (rmsx!=0)
		         double P = ((avgx/rmsx)+1)/2.0;
         else		    P = 0;
		         double G = P * MathLog(1+rmsx) + (1-P) * MathLog(1-rmsx);
		   entropy[i]=G;
	}
	
   for(i=limit; i>=0; i--) SignalBuffer[i]=iMAOnArray(entropy,Bars,SignalSMA,0,MODE_SMA,i);
	return(0);
}